 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdio.h>
 #include <signal.h>
 #include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <net/if.h>

 #ifndef SO_REUSEPORT
 #define SO_REUSEPORT SO_REUSEADDR
 #endif

 struct sockaddr_in6 sin6;

 #define IPPORT 54321

 void Perror(const char *c)
 {
 perror(c);
 exit(1);
 }

 void Usage ()
 {
 fprintf(stderr, "%s\n", "Usage: multi2out6 [-i interface] addr");
 exit(1);
 }

 void BrokenPipe(int Signal)
 {
 signal(SIGPIPE, BrokenPipe);
 return;
 }

 int main(int argc, char **argv)
 {
 struct ipv6_mreq mreq;
 int cc, ccb, ch, s;
 char buf[10240];
 u_int one = 1;
 u_int ifi = 0;

 signal(SIGPIPE, BrokenPipe);
 while ((ch = getopt(argc, argv, "i:")) != -1)
 switch(ch) {
 case 'i':
 if (sscanf(optarg, "%u\0", &ifi) != 1 &&
 (ifi = if_nametoindex(optarg)) == 0)
 Usage();
 break;
 default:
 Usage();
 }
 argc -= optind;
 argv += optind;
 if (argc != 1)
 Usage();

 if ((s = socket(AF_INET6, SOCK_DGRAM, IPPROTO_UDP)) < 0)
 Perror("socket");
 setsockopt(s, SOL_SOCKET, SO_REUSEPORT, &one, sizeof(one));

 #ifdef SIN6_LEN
 sin6.sin6_len = sizeof(sin6);
 #endif
 sin6.sin6_family = AF_INET6;
 sin6.sin6_port = htons(IPPORT);
 if (bind(s, (struct sockaddr *)&sin6, sizeof(sin6)) < 0)
 Perror("bind");
 if (inet_pton(AF_INET6, *argv, &mreq.ipv6mr_multiaddr) != 1)
 Usage();
 mreq.ipv6mr_interface = ifi;
 if (setsockopt(s,IPPROTO_IPV6, IPV6_JOIN_GROUP, &mreq, sizeof(mreq)) < 0)
 Perror("setsockopt IPV6_JOIN_GROUP");
 for (;;) {
 cc = read(s, buf, 10240);
 if (cc < 0)
 Perror("read socket");
 if (cc == 0) {
 fprintf(stderr, "..\n");
 exit (0);
 }
 ccb = write(1, buf, cc);
 if (ccb != cc)
 Perror("write file");
 fprintf(stderr, "<-%d-\n", cc);
 }
 }

